﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using Com.Piwigo.Lib.DTO;

namespace Com.Piwigo.Uploader.DTO
{
    public sealed class ModelManager
    {
         static readonly ModelManagerBase _instance = new ModelManagerBase();

        // Explicit static constructor to tell C# compiler
        // not to mark type as beforefieldinit
        static ModelManager()
        {
        }

        public static ModelManagerBase Instance
        {
            get
            {
                return _instance;
            }
        }

        public class ModelManagerBase 
        {
            public PwgSession sess { get; set; }
            public SelectedPwgAlbumList lstCat { get; set; }
            public Int32 PwgAlbumIdSelected { get; set; }
            public LocalAlbumList lstAlbumLocaux { get; set; }
            public Boolean isConnected { get; set; }
            public String directoryName { get; set; }
            public Uri serveurName { get; set; }
            public String userName { get; set; }
            public String password { get; set; }

            public ModelManagerBase()
            {
                lstCat = new SelectedPwgAlbumList();
                lstAlbumLocaux = new LocalAlbumList();
                isConnected = false;
            }

            internal void resetLstCat()
            {
                if (lstCat == null)
                {
                    lstCat = new SelectedPwgAlbumList();
                }
                else
                {
                    lstCat.Clear();
                }
                lstCat.Add(new SelectedAlbumListItem() { Id = PwgAlbum.RootAlbumId, ShowedValue = "Root album", Data=null, isSelected=true }); 
            }
        }
    }
}
